
### pip install requests
'''
import requests

response = requests.delete("http://127.0.0.1:3399/api/employees/1/")

print(response.text)
print(response.status_code)

pythonData = response.json()
print(pythonData)
print(type(pythonData))
'''

import  requests

def getAllEmployees():
    response = requests.get("http://127.0.0.1:3399/api/employees/")
    if response.status_code == 200:
        try:
            pythonData = response.json()
        except Exception as e:
            print("Status Code :", response.status_code)
            print("Error Message :", e)
        else:
            print("Status Code :", response.status_code)
            print(pythonData)

    elif response.status_code == 404:
        print("Status Code :", response.status_code)
        print("Requested resources not available")

    else:
        print("Status Code :", response.status_code)
        print("Something Went Wrong")


def get_object_by_id(id):
    response = requests.get("http://127.0.0.1:3399/api/employees/"+id+"/")
    if response.status_code == 200:
        try:
            pythonData = response.json()
        except Exception as e:
            print("Status Code :", response.status_code)
            print("Error Message :", e)
        else:
            print("Status Code :", response.status_code)
            print(pythonData)

    elif response.status_code == 404:
        print("Status Code :", response.status_code)
        print("Requested resource not available")

    else:
        print("Status Code :", response.status_code)
        print("Something Went Wrong")


def delete_object_by_id(id):
    response = requests.delete("http://127.0.0.1:3399/api/employees/"+id+"/")
    if response.status_code == 204:
        print("Status Code :", response.status_code)
        print("Requested resource Deleted successfully!")

    elif response.status_code == 404:
        print("Status Code :", response.status_code)
        print("Requested resource not available for Delete")

    else:
        print("Status Code :", response.status_code)
        print("Something Went Wrong")


def create_new_employee():
    employee = {
        "ename": "Shireen",
        "salary": 68000,
        "city": "Delhi",
        "email": "shireen@gmail.com"
    }
    response = requests.post("http://127.0.0.1:3399/api/employees/", data=employee)
    if response.status_code == 201:
        try:
            pythonData = response.json()
        except Exception as e:
            print("Status Code :", response.status_code)
            print("Error Message :", e)
        else:
            print("Status Code :", response.status_code)
            print(pythonData)

    elif response.status_code == 400:
        print("Status Code :", response.status_code)
        print("Requested resource not created in to database table successfully!")

    else:
        print("Status Code :", response.status_code)
        print("Something Went Wrong")


def update_object_by_id(id):
    employee = {
        "ename": "Shireen",
        "salary": 62000,
        "city": "New Delhi",
        "email": "shireen@gmail.com"
    }
    response = requests.put("http://127.0.0.1:3399/api/employees/"+id+"/", data=employee)
    if response.status_code == 200:
        try:
            pythonData = response.json()
        except Exception as e:
            print("Status Code :", response.status_code)
            print("Error Message :", e)
        else:
            print("Status Code :", response.status_code)
            print(pythonData)

    elif response.status_code == 400:
        print("Status Code :", response.status_code)
        print("Requested resource not updated in to database table successfully!")

    else:
        print("Status Code :", response.status_code)
        print("Something Went Wrong")



print("Please select your required operations")
while True:
    print("1. Get all employees")
    print("2. Create a new employee")
    print("3. Get a specific employee")
    print("4. Update a specific employee")
    print("5. Delete a specific employee")
    print("6. Exit")

    user_choice = input("Enter your choice: ")
    if user_choice == "1":
        getAllEmployees()
        break
    elif user_choice == "2":
        create_new_employee()
        break

    elif user_choice == "3":
        id = input("Enter employee ID: ")
        get_object_by_id(id)
        break

    elif user_choice == "4":
        update_object_by_id(input("Enter employee ID: "))
        break

    elif user_choice == "5":
        delete_object_by_id(input("Enter employee ID: "))
        break

    elif user_choice == "6":
        print("Thank you for using our service!")
        break

    else:
        print("Invalid choice")
        print("Please try again")










